var _ = require('lodash');
var compilerSFC = require('@vue/compiler-sfc');

module.exports = function (resoures) {
  const sfc = compilerSFC.parse(resoures);
  let temp = _.trim(sfc.descriptor.template.content);
  let script = _.trim(sfc.descriptor.script ? sfc.descriptor.script.content : '');
  let customBlocks = sfc.descriptor.customBlocks;
  let components = [];

  customBlocks.filter(item => {
    return item.type === 'import'
  }).forEach(({ attrs }) => {
    let { name, src } = attrs;
    let requireCode = `"${name}": require("${src}").default`;
    components.push(requireCode);
  });

  let componentsCode = `{${components.join(',')}}`;

  let stylesCode = [];
  sfc.descriptor.styles.forEach(item => {
    stylesCode.push(`<style>${item.content}</style>`);
  });

  script = _.replace(script, /export\s+default\s+/, 'var ___ready = ');
  
  let codes =  `
    ${script}
    export default {
      template: \`${_.replace(temp, /\n/g, '')}\`,
      styles: \`${_.replace(stylesCode.join(';'), /\n/g, '')}\`,
      ready: typeof ___ready !== "undefined" ? ___ready : () => {},
      components: ${componentsCode},
    };
  `;
  return codes;
}